#define _GNU_SOURCE
#include <err.h>
#include <assert.h>
#include <unistd.h>
#include <stdio.h>
#include <sched.h>
#include <stdlib.h>
#include <sys/prctl.h>
#include <sys/mman.h>
#include <sys/syscall.h>
#include <linux/futex.h>

#define SYSCHK(x) ({          \
  typeof(x) __res = (x);      \
  if (__res == (typeof(x))-1) \
    err(1, "SYSCHK(" #x ")"); \
  __res;                      \
})

static void pin_to(int cpu) {
  cpu_set_t cset;
  CPU_ZERO(&cset);
  CPU_SET(cpu, &cset);
  if (sched_setaffinity(0, sizeof(cpu_set_t), &cset))
    err(1, "set affinity");
}

static int fd;
static char *mapping;

static void reset_file(void) {
  SYSCHK(ftruncate(fd, 0));
  //SYSCHK(ftruncate(fd, 0x1000));
  for (int i=0; i<512-2; i++) {
    assert(SYSCHK(pwrite(fd, "a", 1, 0x1000 * i)) == 1);
  }
  *(volatile char *)mapping = 'a'; /* ensure we have a pagetable */
  SYSCHK(ftruncate(fd, 0x200000));
  system("cat /proc/$PPID/smaps | head -n 30"); printf("\n\n");
}

int main(void) {
  pin_to(4);

  fd = SYSCHK(syscall(__NR_memfd_create, "memfd", 0));
  mapping = SYSCHK(mmap((void*)0x200000, 0x200000, PROT_READ|PROT_WRITE, MAP_SHARED|MAP_FIXED_NOREPLACE, fd, 0));
  reset_file();

  SYSCHK(prctl(PR_SET_NAME, "LOGME"));
  SYSCHK(madvise(mapping, 0x200000, MADV_HUGEPAGE));
  SYSCHK(prctl(PR_SET_NAME, "test"));
  /*
  for (int i=0; i<512; i++)
    *(volatile char *)(mapping+i*0x1000);
    */
  while (1) {
    //system("cat /proc/$PPID/smaps | head -n 30");
    //printf("\n\n\n");
    reset_file();

    SYSCHK(prctl(PR_SET_NAME, "SLOW-GUP"));
    syscall(__NR_futex, mapping, FUTEX_WAIT, 255, NULL, NULL, 0);
    SYSCHK(prctl(PR_SET_NAME, "test"));
    sleep(2);
  }
}
